<?php
/**
* @version      3.3.0 10.12.2011
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

class JTableAvto extends JTable{
    
    function getBuildQueryListProduct($type, $restype, &$filters, &$adv_query, &$adv_from, &$adv_result){
        $jshopConfig = &JSFactory::getConfig();
        $lang = &JSFactory::getLang();
        $user = &JFactory::getUser();
        $db =& JFactory::getDBO();
        
        $groups = implode(',', $user->getAuthorisedViewLevels());
        if ($type=="category"){
            $adv_query .=' AND prod.access IN ('.$groups.')';
        }else{
            $adv_query .=' AND prod.access IN ('.$groups.') AND cat.access IN ('.$groups.')';
        }
        
        if ($jshopConfig->show_delivery_time){            
            $adv_result .= ", prod.delivery_times_id";
        }        
        if ($jshopConfig->admin_show_product_extra_field){
            $adv_result .= getQueryListProductsExtraFields();
        }        
        if ($jshopConfig->product_list_show_vendor){
            $adv_result .= ", prod.vendor_id";
        }        
        if ($jshopConfig->hide_product_not_avaible_stock){
            $adv_query .= " AND prod.product_quantity > 0";
        }
        if ($type!="category" && is_array($filters['categorys']) && count($filters['categorys'])){
            $adv_query .= " AND cat.category_id in (".implode(",",$filters['categorys']).")";
        }
        if ($type!="manufacturer" && is_array($filters['manufacturers']) && count($filters['manufacturers'])){
            $adv_query .= " AND prod.product_manufacturer_id in (".implode(",",$filters['manufacturers']).")";
        }        
        if (is_array($filters['labels']) && count($filters['labels'])){
            $adv_query .= " AND prod.label_id in (".implode(",",$filters['labels']).")";
        }
        if ($type!="vendor" && is_array($filters['vendors']) && count($filters['vendors'])){
            $adv_query .= " AND prod.vendor_id in (".implode(",",$filters['vendors']).")";
        }        
        if (is_array($filters['extra_fields'])){
            foreach($filters['extra_fields'] as $f_id=>$vals){
                if (is_array($vals) && count($vals)){
                    $adv_query .= " AND prod.`extra_field_".$f_id."` in (".implode(",",$vals).")";
                }elseif(is_string($vals) && $vals!=""){
                    $adv_query .= " AND prod.`extra_field_".$f_id."`='".$db->getEscaped($vals)."'";
                }
            }
        }
        
        $this->getBuildQueryListProductFilterPrice($filters, $adv_query, $adv_from);
        
        if ($jshopConfig->product_list_show_qty_stock){
            $adv_result .= ", prod.unlimited";
        }
        
        if ($restype=="count"){
            $adv_result = "";
        }    
    }
    
    function getBuildQueryListProductFilterPrice($filters, &$adv_query, &$adv_from){
        $jshopConfig = &JSFactory::getConfig();
        $multyCurrency = count(JSFactory::getAllCurrency());
        
        if ($multyCurrency > 1){
            $price_from = getCorrectedPriceForQueryFilter($filters['price_from']);
            $price_to = getCorrectedPriceForQueryFilter($filters['price_to']);
            if ($price_from || $price_to){
                $adv_from .= " LEFT JOIN `#__jshopping_currencies` AS cr USING (currency_id) ";
            }
            if ($price_to){
                if ($jshopConfig->product_list_show_min_price){
                    $adv_query .= " AND (( prod.product_price / cr.currency_value )<=".$price_to." OR ( prod.min_price / cr.currency_value)<=" . $price_to." )";
                }else{
                    $adv_query .= " AND ( prod.product_price / cr.currency_value ) <= ".$price_to;
                }
            } 
            
            if ($price_from){
                if ($jshopConfig->product_list_show_min_price){
                    $adv_query .= " AND (( prod.product_price / cr.currency_value ) >= ".$price_from." OR ( prod.min_price / cr.currency_value ) >= " . $price_from." )";
                }else{
                    $adv_query .= " AND ( prod.product_price / cr.currency_value ) >= ".$price_from;
                }
            }
        }else{
            $price_from = getCorrectedPriceForQueryFilter($filters['price_from']);
            $price_to = getCorrectedPriceForQueryFilter($filters['price_to']);
            if ($price_to){
                if ($jshopConfig->product_list_show_min_price){
                    $adv_query .= " AND (prod.product_price<=".$price_to." OR prod.min_price<=" . $price_to." )";
                }else{
                    $adv_query .= " AND prod.product_price <= ".$price_to;
                }
            }
            if ($price_from){
                if ($jshopConfig->product_list_show_min_price){
                    $adv_query .= " AND (prod.product_price >= ".$price_from." OR prod.min_price >= " . $price_from." )";
                }else{
                    $adv_query .= " AND prod.product_price >= ".$price_from;
                }
            }
        }
    }
    
    function getBuildQueryOrderListProduct($order, $orderby, &$adv_from){
        $order_query = "";
        if (!$order) return $order_query;
        $jshopConfig = &JSFactory::getConfig();
        $multyCurrency = count(JSFactory::getAllCurrency());
        if ($multyCurrency>1 && $order=="prod.product_price"){
            if (strpos($adv_from,"jshopping_currencies")===false){
                $adv_from .= " LEFT JOIN `#__jshopping_currencies` AS cr USING (currency_id) ";
            }
            if ($jshopConfig->product_list_show_min_price){
                $order = "prod.min_price/cr.currency_value";    
            }else{
                $order = "prod.product_price/cr.currency_value";
            }
        }
        if ($order=="prod.product_price" && $jshopConfig->product_list_show_min_price){
            $order = "prod.min_price";
        }
        $order_query = " ORDER BY ".$order;
        if ($orderby){
            $order_query .= " ".$orderby;
        }
    return $order_query;
    }
}
?>